/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package it.condarelli.writer.model.world.impl;

import it.condarelli.writer.model.world.Actor;
import it.condarelli.writer.model.world.Book;
import it.condarelli.writer.model.world.Chapter;
import it.condarelli.writer.model.world.Item;
import it.condarelli.writer.model.world.Location;
import it.condarelli.writer.model.world.ScComment;
import it.condarelli.writer.model.world.ScPlot;
import it.condarelli.writer.model.world.ScStatus;
import it.condarelli.writer.model.world.ScType;
import it.condarelli.writer.model.world.Scene;
import it.condarelli.writer.model.world.Timeline;
import it.condarelli.writer.model.world.WorldPackage;

import java.util.Collection;
import java.util.Date;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Scene</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getChapter <em>Chapter</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getType <em>Type</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getPlot <em>Plot</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getTags <em>Tags</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getStatus <em>Status</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getRelevance <em>Relevance</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getTension <em>Tension</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getHumor <em>Humor</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getQuality <em>Quality</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getGoal <em>Goal</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getConflict <em>Conflict</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getOutcome <em>Outcome</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getActor <em>Actor</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getLocation <em>Location</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getItem <em>Item</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getWordCount <em>Word Count</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.SceneImpl#getComments <em>Comments</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SceneImpl extends IBaseImpl implements Scene {
   /**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
   protected static final ScType TYPE_EDEFAULT = ScType.ACTION;

   /**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
   protected ScType type = TYPE_EDEFAULT;

   /**
	 * The default value of the '{@link #getPlot() <em>Plot</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getPlot()
	 * @generated
	 * @ordered
	 */
   protected static final ScPlot PLOT_EDEFAULT = ScPlot.PLOT;

   /**
	 * The cached value of the '{@link #getPlot() <em>Plot</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getPlot()
	 * @generated
	 * @ordered
	 */
   protected ScPlot plot = PLOT_EDEFAULT;

   /**
	 * The default value of the '{@link #getTags() <em>Tags</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getTags()
	 * @generated
	 * @ordered
	 */
   protected static final String TAGS_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getTags() <em>Tags</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getTags()
	 * @generated
	 * @ordered
	 */
   protected String tags = TAGS_EDEFAULT;

   /**
	 * The default value of the '{@link #getStatus() <em>Status</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getStatus()
	 * @generated
	 * @ordered
	 */
   protected static final ScStatus STATUS_EDEFAULT = ScStatus.OUTLINE;

   /**
	 * The cached value of the '{@link #getStatus() <em>Status</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getStatus()
	 * @generated
	 * @ordered
	 */
   protected ScStatus status = STATUS_EDEFAULT;

   /**
	 * The default value of the '{@link #getRelevance() <em>Relevance</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getRelevance()
	 * @generated
	 * @ordered
	 */
   protected static final int RELEVANCE_EDEFAULT = 0;

   /**
	 * The cached value of the '{@link #getRelevance() <em>Relevance</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getRelevance()
	 * @generated
	 * @ordered
	 */
   protected int relevance = RELEVANCE_EDEFAULT;

   /**
	 * The default value of the '{@link #getTension() <em>Tension</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getTension()
	 * @generated
	 * @ordered
	 */
   protected static final int TENSION_EDEFAULT = 0;

   /**
	 * The cached value of the '{@link #getTension() <em>Tension</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getTension()
	 * @generated
	 * @ordered
	 */
   protected int tension = TENSION_EDEFAULT;

   /**
	 * The default value of the '{@link #getHumor() <em>Humor</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getHumor()
	 * @generated
	 * @ordered
	 */
   protected static final int HUMOR_EDEFAULT = 0;

   /**
	 * The cached value of the '{@link #getHumor() <em>Humor</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getHumor()
	 * @generated
	 * @ordered
	 */
   protected int humor = HUMOR_EDEFAULT;

   /**
	 * The default value of the '{@link #getQuality() <em>Quality</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getQuality()
	 * @generated
	 * @ordered
	 */
   protected static final int QUALITY_EDEFAULT = 0;

   /**
	 * The cached value of the '{@link #getQuality() <em>Quality</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getQuality()
	 * @generated
	 * @ordered
	 */
   protected int quality = QUALITY_EDEFAULT;

   /**
	 * The default value of the '{@link #getGoal() <em>Goal</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getGoal()
	 * @generated
	 * @ordered
	 */
   protected static final String GOAL_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getGoal() <em>Goal</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getGoal()
	 * @generated
	 * @ordered
	 */
   protected String goal = GOAL_EDEFAULT;

   /**
	 * The default value of the '{@link #getConflict() <em>Conflict</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getConflict()
	 * @generated
	 * @ordered
	 */
   protected static final String CONFLICT_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getConflict() <em>Conflict</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getConflict()
	 * @generated
	 * @ordered
	 */
   protected String conflict = CONFLICT_EDEFAULT;

   /**
	 * The default value of the '{@link #getOutcome() <em>Outcome</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getOutcome()
	 * @generated
	 * @ordered
	 */
   protected static final String OUTCOME_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getOutcome() <em>Outcome</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getOutcome()
	 * @generated
	 * @ordered
	 */
   protected String outcome = OUTCOME_EDEFAULT;

   /**
	 * The cached value of the '{@link #getActor() <em>Actor</em>}' reference list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getActor()
	 * @generated
	 * @ordered
	 */
   protected EList<Actor> actor;

   /**
	 * The cached value of the '{@link #getLocation() <em>Location</em>}' reference list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getLocation()
	 * @generated
	 * @ordered
	 */
   protected EList<Location> location;

   /**
	 * The cached value of the '{@link #getItem() <em>Item</em>}' reference list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getItem()
	 * @generated
	 * @ordered
	 */
   protected EList<Item> item;

   /**
	 * The default value of the '{@link #getWordCount() <em>Word Count</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getWordCount()
	 * @generated
	 * @ordered
	 */
   protected static final int WORD_COUNT_EDEFAULT = 0;

   /**
	 * The cached value of the '{@link #getComments() <em>Comments</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComments()
	 * @generated
	 * @ordered
	 */
	protected EList<ScComment> comments;

			/**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   protected SceneImpl() {
		super();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   protected EClass eStaticClass() {
		return WorldPackage.Literals.SCENE;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Chapter getChapter() {
		if (eContainerFeatureID() != WorldPackage.SCENE__CHAPTER) return null;
		return (Chapter)eContainer();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public NotificationChain basicSetChapter(Chapter newChapter, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newChapter, WorldPackage.SCENE__CHAPTER, msgs);
		return msgs;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setChapter(Chapter newChapter) {
		if (newChapter != eInternalContainer() || (eContainerFeatureID() != WorldPackage.SCENE__CHAPTER && newChapter != null)) {
			if (EcoreUtil.isAncestor(this, newChapter))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newChapter != null)
				msgs = ((InternalEObject)newChapter).eInverseAdd(this, WorldPackage.CHAPTER__SCENE, Chapter.class, msgs);
			msgs = basicSetChapter(newChapter, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__CHAPTER, newChapter, newChapter));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public ScType getType() {
		return type;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setType(ScType newType) {
		ScType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__TYPE, oldType, type));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public ScPlot getPlot() {
		return plot;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setPlot(ScPlot newPlot) {
		ScPlot oldPlot = plot;
		plot = newPlot == null ? PLOT_EDEFAULT : newPlot;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__PLOT, oldPlot, plot));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getTags() {
		return tags;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setTags(String newTags) {
		String oldTags = tags;
		tags = newTags;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__TAGS, oldTags, tags));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public ScStatus getStatus() {
		return status;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setStatus(ScStatus newStatus) {
		ScStatus oldStatus = status;
		status = newStatus == null ? STATUS_EDEFAULT : newStatus;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__STATUS, oldStatus, status));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public int getRelevance() {
		return relevance;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setRelevance(int newRelevance) {
		int oldRelevance = relevance;
		relevance = newRelevance;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__RELEVANCE, oldRelevance, relevance));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public int getTension() {
		return tension;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setTension(int newTension) {
		int oldTension = tension;
		tension = newTension;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__TENSION, oldTension, tension));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public int getHumor() {
		return humor;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setHumor(int newHumor) {
		int oldHumor = humor;
		humor = newHumor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__HUMOR, oldHumor, humor));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public int getQuality() {
		return quality;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setQuality(int newQuality) {
		int oldQuality = quality;
		quality = newQuality;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__QUALITY, oldQuality, quality));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getGoal() {
		return goal;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setGoal(String newGoal) {
		String oldGoal = goal;
		goal = newGoal;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__GOAL, oldGoal, goal));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getConflict() {
		return conflict;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setConflict(String newConflict) {
		String oldConflict = conflict;
		conflict = newConflict;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__CONFLICT, oldConflict, conflict));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getOutcome() {
		return outcome;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setOutcome(String newOutcome) {
		String oldOutcome = outcome;
		outcome = newOutcome;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.SCENE__OUTCOME, oldOutcome, outcome));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public EList<Actor> getActor() {
		if (actor == null) {
			actor = new EObjectResolvingEList<Actor>(Actor.class, this, WorldPackage.SCENE__ACTOR);
		}
		return actor;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public EList<Location> getLocation() {
		if (location == null) {
			location = new EObjectResolvingEList<Location>(Location.class, this, WorldPackage.SCENE__LOCATION);
		}
		return location;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public EList<Item> getItem() {
		if (item == null) {
			item = new EObjectResolvingEList<Item>(Item.class, this, WorldPackage.SCENE__ITEM);
		}
		return item;
	}

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
    private int cachedWorldCount = -1;
   public int getWordCount() {
        if (cachedWorldCount < 0) {
            String content = getContent();
            if (content == null)
                cachedWorldCount = 0;
            else {
                String[] words = content.split("\\W+");
                cachedWorldCount = words.length;
            }
        }
        return cachedWorldCount;
    }
    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ScComment> getComments() {
		if (comments == null) {
			comments = new EObjectContainmentWithInverseEList<ScComment>(ScComment.class, this, WorldPackage.SCENE__COMMENTS, WorldPackage.SC_COMMENT__SCENE);
		}
		return comments;
	}

				@Override
    public void setContent(String newContent) {
        cachedWorldCount = -1;
        super.setContent(newContent);
   }

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorldPackage.SCENE__CHAPTER:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetChapter((Chapter)otherEnd, msgs);
			case WorldPackage.SCENE__COMMENTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getComments()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorldPackage.SCENE__CHAPTER:
				return basicSetChapter(null, msgs);
			case WorldPackage.SCENE__COMMENTS:
				return ((InternalEList<?>)getComments()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case WorldPackage.SCENE__CHAPTER:
				return eInternalContainer().eInverseRemove(this, WorldPackage.CHAPTER__SCENE, Chapter.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case WorldPackage.SCENE__CHAPTER:
				return getChapter();
			case WorldPackage.SCENE__TYPE:
				return getType();
			case WorldPackage.SCENE__PLOT:
				return getPlot();
			case WorldPackage.SCENE__TAGS:
				return getTags();
			case WorldPackage.SCENE__STATUS:
				return getStatus();
			case WorldPackage.SCENE__RELEVANCE:
				return getRelevance();
			case WorldPackage.SCENE__TENSION:
				return getTension();
			case WorldPackage.SCENE__HUMOR:
				return getHumor();
			case WorldPackage.SCENE__QUALITY:
				return getQuality();
			case WorldPackage.SCENE__GOAL:
				return getGoal();
			case WorldPackage.SCENE__CONFLICT:
				return getConflict();
			case WorldPackage.SCENE__OUTCOME:
				return getOutcome();
			case WorldPackage.SCENE__ACTOR:
				return getActor();
			case WorldPackage.SCENE__LOCATION:
				return getLocation();
			case WorldPackage.SCENE__ITEM:
				return getItem();
			case WorldPackage.SCENE__WORD_COUNT:
				return getWordCount();
			case WorldPackage.SCENE__COMMENTS:
				return getComments();
		}
		return super.eGet(featureID, resolve, coreType);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case WorldPackage.SCENE__CHAPTER:
				setChapter((Chapter)newValue);
				return;
			case WorldPackage.SCENE__TYPE:
				setType((ScType)newValue);
				return;
			case WorldPackage.SCENE__PLOT:
				setPlot((ScPlot)newValue);
				return;
			case WorldPackage.SCENE__TAGS:
				setTags((String)newValue);
				return;
			case WorldPackage.SCENE__STATUS:
				setStatus((ScStatus)newValue);
				return;
			case WorldPackage.SCENE__RELEVANCE:
				setRelevance((Integer)newValue);
				return;
			case WorldPackage.SCENE__TENSION:
				setTension((Integer)newValue);
				return;
			case WorldPackage.SCENE__HUMOR:
				setHumor((Integer)newValue);
				return;
			case WorldPackage.SCENE__QUALITY:
				setQuality((Integer)newValue);
				return;
			case WorldPackage.SCENE__GOAL:
				setGoal((String)newValue);
				return;
			case WorldPackage.SCENE__CONFLICT:
				setConflict((String)newValue);
				return;
			case WorldPackage.SCENE__OUTCOME:
				setOutcome((String)newValue);
				return;
			case WorldPackage.SCENE__ACTOR:
				getActor().clear();
				getActor().addAll((Collection<? extends Actor>)newValue);
				return;
			case WorldPackage.SCENE__LOCATION:
				getLocation().clear();
				getLocation().addAll((Collection<? extends Location>)newValue);
				return;
			case WorldPackage.SCENE__ITEM:
				getItem().clear();
				getItem().addAll((Collection<? extends Item>)newValue);
				return;
			case WorldPackage.SCENE__COMMENTS:
				getComments().clear();
				getComments().addAll((Collection<? extends ScComment>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public void eUnset(int featureID) {
		switch (featureID) {
			case WorldPackage.SCENE__CHAPTER:
				setChapter((Chapter)null);
				return;
			case WorldPackage.SCENE__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case WorldPackage.SCENE__PLOT:
				setPlot(PLOT_EDEFAULT);
				return;
			case WorldPackage.SCENE__TAGS:
				setTags(TAGS_EDEFAULT);
				return;
			case WorldPackage.SCENE__STATUS:
				setStatus(STATUS_EDEFAULT);
				return;
			case WorldPackage.SCENE__RELEVANCE:
				setRelevance(RELEVANCE_EDEFAULT);
				return;
			case WorldPackage.SCENE__TENSION:
				setTension(TENSION_EDEFAULT);
				return;
			case WorldPackage.SCENE__HUMOR:
				setHumor(HUMOR_EDEFAULT);
				return;
			case WorldPackage.SCENE__QUALITY:
				setQuality(QUALITY_EDEFAULT);
				return;
			case WorldPackage.SCENE__GOAL:
				setGoal(GOAL_EDEFAULT);
				return;
			case WorldPackage.SCENE__CONFLICT:
				setConflict(CONFLICT_EDEFAULT);
				return;
			case WorldPackage.SCENE__OUTCOME:
				setOutcome(OUTCOME_EDEFAULT);
				return;
			case WorldPackage.SCENE__ACTOR:
				getActor().clear();
				return;
			case WorldPackage.SCENE__LOCATION:
				getLocation().clear();
				return;
			case WorldPackage.SCENE__ITEM:
				getItem().clear();
				return;
			case WorldPackage.SCENE__COMMENTS:
				getComments().clear();
				return;
		}
		super.eUnset(featureID);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public boolean eIsSet(int featureID) {
		switch (featureID) {
			case WorldPackage.SCENE__CHAPTER:
				return getChapter() != null;
			case WorldPackage.SCENE__TYPE:
				return type != TYPE_EDEFAULT;
			case WorldPackage.SCENE__PLOT:
				return plot != PLOT_EDEFAULT;
			case WorldPackage.SCENE__TAGS:
				return TAGS_EDEFAULT == null ? tags != null : !TAGS_EDEFAULT.equals(tags);
			case WorldPackage.SCENE__STATUS:
				return status != STATUS_EDEFAULT;
			case WorldPackage.SCENE__RELEVANCE:
				return relevance != RELEVANCE_EDEFAULT;
			case WorldPackage.SCENE__TENSION:
				return tension != TENSION_EDEFAULT;
			case WorldPackage.SCENE__HUMOR:
				return humor != HUMOR_EDEFAULT;
			case WorldPackage.SCENE__QUALITY:
				return quality != QUALITY_EDEFAULT;
			case WorldPackage.SCENE__GOAL:
				return GOAL_EDEFAULT == null ? goal != null : !GOAL_EDEFAULT.equals(goal);
			case WorldPackage.SCENE__CONFLICT:
				return CONFLICT_EDEFAULT == null ? conflict != null : !CONFLICT_EDEFAULT.equals(conflict);
			case WorldPackage.SCENE__OUTCOME:
				return OUTCOME_EDEFAULT == null ? outcome != null : !OUTCOME_EDEFAULT.equals(outcome);
			case WorldPackage.SCENE__ACTOR:
				return actor != null && !actor.isEmpty();
			case WorldPackage.SCENE__LOCATION:
				return location != null && !location.isEmpty();
			case WorldPackage.SCENE__ITEM:
				return item != null && !item.isEmpty();
			case WorldPackage.SCENE__WORD_COUNT:
				return getWordCount() != WORD_COUNT_EDEFAULT;
			case WorldPackage.SCENE__COMMENTS:
				return comments != null && !comments.isEmpty();
		}
		return super.eIsSet(featureID);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (type: ");
		result.append(type);
		result.append(", plot: ");
		result.append(plot);
		result.append(", tags: ");
		result.append(tags);
		result.append(", status: ");
		result.append(status);
		result.append(", relevance: ");
		result.append(relevance);
		result.append(", tension: ");
		result.append(tension);
		result.append(", humor: ");
		result.append(humor);
		result.append(", quality: ");
		result.append(quality);
		result.append(", goal: ");
		result.append(goal);
		result.append(", conflict: ");
		result.append(conflict);
		result.append(", outcome: ");
		result.append(outcome);
		result.append(')');
		return result.toString();
	}

    // begin of hand-coded methods
    
    public Scene nextScene() throws Exception {
        Chapter c = getChapter();
        if (c == null)
            return null;
        int idx = c.getScene().indexOf(this);
        if (idx < 0) {
            throw (new Exception("scene not found!"));
        }
        idx++;
        while (idx >= c.getScene().size()) {
            Book b = c.getBook();
            int j = b.getChapter().indexOf(c);
            if (j < 0) {
                throw (new Exception("chapter not found!"));
            }
            j++;
            if (j >= b.getChapter().size())
                return null;
            c = b.getChapter().get(j);
            idx = 0;
        }
        Scene s = c.getScene().get(idx);

        return s;
    }

    public Scene prevScene() throws Exception {
            Chapter c = getChapter();
            if (c == null)
                return null;
            int idx = c.getScene().indexOf(this);
            if (idx < 0) {
                throw (new Exception("scene not found!"));
            }
            idx--;
            while ((idx < 0) || (c.getScene().size() == 0)) {
                Book b = c.getBook();
                int j = b.getChapter().indexOf(c);
                if (j < 0) {
                    throw (new Exception("chapter not found!"));
                }
                j--;
                if (j < 0)
                    return null;
                c = b.getChapter().get(j);
                idx = c.getScene().size() - 1;
            }
            Scene s = c.getScene().get(idx);

        return s;
    }

    @Override
    public Timeline getTimeline() {
        Timeline tl = super.getTimeline();
        if (tl == null) {
            tl = WorldFactoryImpl.eINSTANCE.createTimeline();
            //tl.setCaption(getTitle());
            
            try {
                Scene ps = prevScene();
                Scene ns = nextScene();
                if (ps != null) {
                    Timeline pt = ps.getTimeline();
                    if (ns != null) {
                        // ps &  ns
                        // insert between two scenes: use standard duration or 7/9 of gap, whichever is smaller
                        Timeline nt = ns.getTimeline();
                        long all = nt.getMillis() - pt.getMillis();
                        long newdur = (all / 9 ) * 7;
                        if (newdur > Scene.DEFAULT_DURATION)
                            newdur = Scene.DEFAULT_DURATION;
                        long newgap = (all - newdur) / 2;
                        newdur = all - 2 * newgap; // to avoid rounding errors!
                        tl.setDuration(newdur);
                        tl.setMillis(pt.getMillis() + pt.getDuration() + newgap);
                        tl.setPrev(pt);
                        tl.setNext(nt);
                        pt.setNext(tl);
                        nt.setPrev(tl);
                    } else {
                        // ps & !ns
                        // add after last scene with default gap and duration
                        tl.setMillis(pt.getMillis() + pt.getDuration() + Scene.DEFAULT_GAP);
                        tl.setDuration(Scene.DEFAULT_DURATION);
                        tl.setPrev(pt);
                        pt.setNext(tl);
                    }
                } else {
                    if (ns != null) {
                        //!ps &  ns
                        // insert before first scene: steal half of first scene duration with token gap
                        Timeline nt = ns.getTimeline();
                        long all = nt.getDuration();
                        long newdur = (all / 9 ) * 4;
                        long newgap = all - 2 * newdur; // to avoid rounding errors
                        tl.setDuration(newdur);
                        tl.setMillis(nt.getMillis());
                        tl.setNext(nt);
                        nt.setMillis(tl.getMillis() + newdur + newgap);
                        nt.setDuration(newdur);
                        nt.setPrev(tl);
                    } else {
                        //!ps & !ns
                        // just this scene with default duration
                        Date now = new Date();
                        tl.setMillis(now.getTime());
                        tl.setDuration(Scene.DEFAULT_DURATION);
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
                return null;
            }
            
            setTimeline(tl);
        }
        return tl;
    }
} //SceneImpl
