package it.condarelli.e4.resourcemanager;


import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.RGB;

public interface IResourceManager {
	 public String getFontName(FontData[] fds);
	 public Font getFont(String name);
	 public String getColorName(RGB rgb);
	 public Color getColor(String name);
	 public Color getColor(RGB rgb);
	 public ImageDescriptor getImageDescriptor(String name);
	 public ImageDescriptor getImageDescriptor(String name, int size);
	 public Image getImage(String name, int size);
	 public ImageData scale(ImageData in, int size);
	 public Image scale(Image in, int size);
}
