/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package it.condarelli.writer.model.world.impl;

import it.condarelli.writer.model.world.Actor;
import it.condarelli.writer.model.world.Book;
import it.condarelli.writer.model.world.Chapter;
import it.condarelli.writer.model.world.Item;
import it.condarelli.writer.model.world.Location;
import it.condarelli.writer.model.world.Project;
import it.condarelli.writer.model.world.Scene;
import it.condarelli.writer.model.world.Timeline;
import it.condarelli.writer.model.world.World;
import it.condarelli.writer.model.world.WorldPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Book</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link it.condarelli.writer.model.world.impl.BookImpl#getWorld <em>World</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.BookImpl#getProject <em>Project</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.BookImpl#getActor <em>Actor</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.BookImpl#getChapter <em>Chapter</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.BookImpl#getLocation <em>Location</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.BookImpl#getItem <em>Item</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.BookImpl#getWordCount <em>Word Count</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BookImpl extends IBaseImpl implements Book {
   /**
	 * The cached value of the '{@link #getProject() <em>Project</em>}' reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getProject()
	 * @generated
	 * @ordered
	 */
   protected Project project;

   /**
	 * The cached value of the '{@link #getActor() <em>Actor</em>}' containment reference list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getActor()
	 * @generated
	 * @ordered
	 */
   protected EList<Actor> actor;

   /**
	 * The cached value of the '{@link #getChapter() <em>Chapter</em>}' containment reference list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getChapter()
	 * @generated
	 * @ordered
	 */
   protected EList<Chapter> chapter;

   /**
	 * The cached value of the '{@link #getLocation() <em>Location</em>}' containment reference list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getLocation()
	 * @generated
	 * @ordered
	 */
   protected EList<Location> location;

   /**
	 * The cached value of the '{@link #getItem() <em>Item</em>}' containment reference list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getItem()
	 * @generated
	 * @ordered
	 */
   protected EList<Item> item;

   /**
	 * The default value of the '{@link #getWordCount() <em>Word Count</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getWordCount()
	 * @generated
	 * @ordered
	 */
   protected static final int WORD_COUNT_EDEFAULT = 0;

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   protected BookImpl() {
		super();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   protected EClass eStaticClass() {
		return WorldPackage.Literals.BOOK;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public World getWorld() {
		if (eContainerFeatureID() != WorldPackage.BOOK__WORLD) return null;
		return (World)eContainer();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public NotificationChain basicSetWorld(World newWorld, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newWorld, WorldPackage.BOOK__WORLD, msgs);
		return msgs;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setWorld(World newWorld) {
		if (newWorld != eInternalContainer() || (eContainerFeatureID() != WorldPackage.BOOK__WORLD && newWorld != null)) {
			if (EcoreUtil.isAncestor(this, newWorld))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newWorld != null)
				msgs = ((InternalEObject)newWorld).eInverseAdd(this, WorldPackage.WORLD__BOOK, World.class, msgs);
			msgs = basicSetWorld(newWorld, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.BOOK__WORLD, newWorld, newWorld));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Project getProject() {
		if (project != null && project.eIsProxy()) {
			InternalEObject oldProject = (InternalEObject)project;
			project = (Project)eResolveProxy(oldProject);
			if (project != oldProject) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, WorldPackage.BOOK__PROJECT, oldProject, project));
			}
		}
		return project;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Project basicGetProject() {
		return project;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setProject(Project newProject) {
		Project oldProject = project;
		project = newProject;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.BOOK__PROJECT, oldProject, project));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public EList<Actor> getActor() {
		if (actor == null) {
			actor = new EObjectContainmentEList<Actor>(Actor.class, this, WorldPackage.BOOK__ACTOR);
		}
		return actor;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public EList<Chapter> getChapter() {
		if (chapter == null) {
			chapter = new EObjectContainmentWithInverseEList<Chapter>(Chapter.class, this, WorldPackage.BOOK__CHAPTER, WorldPackage.CHAPTER__BOOK);
		}
		return chapter;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public EList<Location> getLocation() {
		if (location == null) {
			location = new EObjectContainmentEList<Location>(Location.class, this, WorldPackage.BOOK__LOCATION);
		}
		return location;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public EList<Item> getItem() {
		if (item == null) {
			item = new EObjectContainmentEList<Item>(Item.class, this, WorldPackage.BOOK__ITEM);
		}
		return item;
	}

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public int getWordCount() {
        int words = 0;
        for (Chapter c : getChapter()) {
            words += c.getWordCount();
        }
        return words;
   }

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorldPackage.BOOK__WORLD:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetWorld((World)otherEnd, msgs);
			case WorldPackage.BOOK__CHAPTER:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getChapter()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorldPackage.BOOK__WORLD:
				return basicSetWorld(null, msgs);
			case WorldPackage.BOOK__ACTOR:
				return ((InternalEList<?>)getActor()).basicRemove(otherEnd, msgs);
			case WorldPackage.BOOK__CHAPTER:
				return ((InternalEList<?>)getChapter()).basicRemove(otherEnd, msgs);
			case WorldPackage.BOOK__LOCATION:
				return ((InternalEList<?>)getLocation()).basicRemove(otherEnd, msgs);
			case WorldPackage.BOOK__ITEM:
				return ((InternalEList<?>)getItem()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case WorldPackage.BOOK__WORLD:
				return eInternalContainer().eInverseRemove(this, WorldPackage.WORLD__BOOK, World.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case WorldPackage.BOOK__WORLD:
				return getWorld();
			case WorldPackage.BOOK__PROJECT:
				if (resolve) return getProject();
				return basicGetProject();
			case WorldPackage.BOOK__ACTOR:
				return getActor();
			case WorldPackage.BOOK__CHAPTER:
				return getChapter();
			case WorldPackage.BOOK__LOCATION:
				return getLocation();
			case WorldPackage.BOOK__ITEM:
				return getItem();
			case WorldPackage.BOOK__WORD_COUNT:
				return getWordCount();
		}
		return super.eGet(featureID, resolve, coreType);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case WorldPackage.BOOK__WORLD:
				setWorld((World)newValue);
				return;
			case WorldPackage.BOOK__PROJECT:
				setProject((Project)newValue);
				return;
			case WorldPackage.BOOK__ACTOR:
				getActor().clear();
				getActor().addAll((Collection<? extends Actor>)newValue);
				return;
			case WorldPackage.BOOK__CHAPTER:
				getChapter().clear();
				getChapter().addAll((Collection<? extends Chapter>)newValue);
				return;
			case WorldPackage.BOOK__LOCATION:
				getLocation().clear();
				getLocation().addAll((Collection<? extends Location>)newValue);
				return;
			case WorldPackage.BOOK__ITEM:
				getItem().clear();
				getItem().addAll((Collection<? extends Item>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public void eUnset(int featureID) {
		switch (featureID) {
			case WorldPackage.BOOK__WORLD:
				setWorld((World)null);
				return;
			case WorldPackage.BOOK__PROJECT:
				setProject((Project)null);
				return;
			case WorldPackage.BOOK__ACTOR:
				getActor().clear();
				return;
			case WorldPackage.BOOK__CHAPTER:
				getChapter().clear();
				return;
			case WorldPackage.BOOK__LOCATION:
				getLocation().clear();
				return;
			case WorldPackage.BOOK__ITEM:
				getItem().clear();
				return;
		}
		super.eUnset(featureID);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public boolean eIsSet(int featureID) {
		switch (featureID) {
			case WorldPackage.BOOK__WORLD:
				return getWorld() != null;
			case WorldPackage.BOOK__PROJECT:
				return project != null;
			case WorldPackage.BOOK__ACTOR:
				return actor != null && !actor.isEmpty();
			case WorldPackage.BOOK__CHAPTER:
				return chapter != null && !chapter.isEmpty();
			case WorldPackage.BOOK__LOCATION:
				return location != null && !location.isEmpty();
			case WorldPackage.BOOK__ITEM:
				return item != null && !item.isEmpty();
			case WorldPackage.BOOK__WORD_COUNT:
				return getWordCount() != WORD_COUNT_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

    // begin of hand-coded methods

    @Override
    public Timeline getTimeline() {
        Timeline tl = super.getTimeline();
        if (tl == null) {
            tl = WorldFactoryImpl.eINSTANCE.createTimeline();
            tl.setCaption(getTitle());
        }
        // check bounds
        long min = Long.MAX_VALUE;
        long max = Long.MIN_VALUE;
        for (Chapter ch : getChapter())
            for (Scene sc : ch.getScene()) {
                Timeline st = sc.getTimeline();
                long l = st.getMillis();
                if (min > l)
                    min = l;
                l += st.getDuration();
                if (max < l)
                    max = l;
            }
        
        if ((tl.getMillis() > min) || (tl.getMillis() < (min - 365*24*60*60*1000)))
            tl.setMillis(min);
        long len = max - tl.getMillis();
        if ((tl.getDuration() < len) || (tl.getDuration() > (len + 365*24*60*60*1000)))
            tl.setDuration(len);

        return tl;
    }
} //BookImpl
