/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package it.condarelli.writer.model.world.impl;

import it.condarelli.writer.model.world.Actor;
import it.condarelli.writer.model.world.Book;
import it.condarelli.writer.model.world.Chapter;
import it.condarelli.writer.model.world.IBase;
import it.condarelli.writer.model.world.Item;
import it.condarelli.writer.model.world.Location;
import it.condarelli.writer.model.world.Scene;
import it.condarelli.writer.model.world.Timeline;
import it.condarelli.writer.model.world.World;
import it.condarelli.writer.model.world.WorldPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.common.util.UniqueEList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.swt.graphics.Image;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>IBase</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#getTitle <em>Title</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#isUnused <em>Unused</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#getDesc <em>Desc</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#getContent <em>Content</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#getTimeline <em>Timeline</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#getImage <em>Image</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#getActors <em>Actors</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#getLocations <em>Locations</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#getItems <em>Items</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.IBaseImpl#getRoot <em>Root</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class IBaseImpl extends EObjectImpl implements IBase {
   /**
	 * The default value of the '{@link #getTitle() <em>Title</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getTitle()
	 * @generated
	 * @ordered
	 */
   protected static final String TITLE_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getTitle() <em>Title</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getTitle()
	 * @generated
	 * @ordered
	 */
   protected String title = TITLE_EDEFAULT;

   /**
	 * The default value of the '{@link #isUnused() <em>Unused</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #isUnused()
	 * @generated
	 * @ordered
	 */
   protected static final boolean UNUSED_EDEFAULT = false;

   /**
	 * The cached value of the '{@link #isUnused() <em>Unused</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #isUnused()
	 * @generated
	 * @ordered
	 */
   protected boolean unused = UNUSED_EDEFAULT;

   /**
	 * The default value of the '{@link #getDesc() <em>Desc</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getDesc()
	 * @generated
	 * @ordered
	 */
   protected static final String DESC_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getDesc() <em>Desc</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getDesc()
	 * @generated
	 * @ordered
	 */
   protected String desc = DESC_EDEFAULT;

   /**
	 * This is true if the Desc attribute has been set.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
   protected boolean descESet;

   /**
	 * The default value of the '{@link #getContent() <em>Content</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getContent()
	 * @generated
	 * @ordered
	 */
   protected static final String CONTENT_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getContent() <em>Content</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getContent()
	 * @generated
	 * @ordered
	 */
   protected String content = CONTENT_EDEFAULT;

   /**
	 * The cached value of the '{@link #getTimeline() <em>Timeline</em>}' containment reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getTimeline()
	 * @generated
	 * @ordered
	 */
   protected Timeline timeline;

   /**
	 * The default value of the '{@link #getImage() <em>Image</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getImage()
	 * @generated
	 * @ordered
	 */
   protected static final Image IMAGE_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getImage() <em>Image</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getImage()
	 * @generated
	 * @ordered
	 */
   protected Image image = IMAGE_EDEFAULT;

   /**
	 * This is true if the Image attribute has been set.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
   protected boolean imageESet;

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   protected IBaseImpl() {
		super();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   protected EClass eStaticClass() {
		return WorldPackage.Literals.IBASE;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getTitle() {
		return title;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setTitle(String newTitle) {
		String oldTitle = title;
		title = newTitle;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.IBASE__TITLE, oldTitle, title));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public boolean isUnused() {
		return unused;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setUnused(boolean newUnused) {
		boolean oldUnused = unused;
		unused = newUnused;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.IBASE__UNUSED, oldUnused, unused));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getDesc() {
		return desc;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setDesc(String newDesc) {
		String oldDesc = desc;
		desc = newDesc;
		boolean oldDescESet = descESet;
		descESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.IBASE__DESC, oldDesc, desc, !oldDescESet));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void unsetDesc() {
		String oldDesc = desc;
		boolean oldDescESet = descESet;
		desc = DESC_EDEFAULT;
		descESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, WorldPackage.IBASE__DESC, oldDesc, DESC_EDEFAULT, oldDescESet));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public boolean isSetDesc() {
		return descESet;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getContent() {
		return content;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setContent(String newContent) {
		String oldContent = content;
		content = newContent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.IBASE__CONTENT, oldContent, content));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Timeline getTimeline() {
		return timeline;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public NotificationChain basicSetTimeline(Timeline newTimeline, NotificationChain msgs) {
		Timeline oldTimeline = timeline;
		timeline = newTimeline;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, WorldPackage.IBASE__TIMELINE, oldTimeline, newTimeline);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setTimeline(Timeline newTimeline) {
		if (newTimeline != timeline) {
			NotificationChain msgs = null;
			if (timeline != null)
				msgs = ((InternalEObject)timeline).eInverseRemove(this, WorldPackage.TIMELINE__PARENT, Timeline.class, msgs);
			if (newTimeline != null)
				msgs = ((InternalEObject)newTimeline).eInverseAdd(this, WorldPackage.TIMELINE__PARENT, Timeline.class, msgs);
			msgs = basicSetTimeline(newTimeline, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.IBASE__TIMELINE, newTimeline, newTimeline));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Image getImage() {
		return image;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setImage(Image newImage) {
		Image oldImage = image;
		image = newImage;
		boolean oldImageESet = imageESet;
		imageESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.IBASE__IMAGE, oldImage, image, !oldImageESet));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void unsetImage() {
		Image oldImage = image;
		boolean oldImageESet = imageESet;
		image = IMAGE_EDEFAULT;
		imageESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, WorldPackage.IBASE__IMAGE, oldImage, IMAGE_EDEFAULT, oldImageESet));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public boolean isSetImage() {
		return imageESet;
	}

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public EList<Actor> getActors() {
      // TODO: implement this method to return the 'Actors' reference list
      // Ensure that you remove @generated or mark it @generated NOT
      // The list is expected to implement org.eclipse.emf.ecore.util.InternalEList and org.eclipse.emf.ecore.EStructuralFeature.Setting
      // so it's likely that an appropriate subclass of org.eclipse.emf.ecore.util.EcoreEList should be used.
        if (this instanceof World) {
            World w = (World) this;
            EList<Actor> al = new UniqueEList<Actor>(w.getActor());
            al.addAll(w.getActor());
            for (Book b : w.getBook()) {
                for (Actor a : b.getActor()) {
                    if (al.contains(a))
                        System.out.printf("WARNING: Duplicate Actor '%s' in book '%s'", a.getName(), b.getTitle());
                    else
                        al.add(a);
                }
                for (Chapter c : b.getChapter()) 
                    for (Actor a : c.getActor()) {
                        if (al.contains(a))
                            System.out.printf("WARNING: Duplicate Actor '%s' in chapter '%s  'book '%s'", a.getName(), c.getTitle(), b.getTitle());
                        else
                            al.add(a);
                    }
            }
            return al;
        } else if (this instanceof Book) {
            Book b = (Book) this;
            EList<Actor> al = new UniqueEList<Actor>(b.getWorld().getActor());
            al.addAll(b.getActor());
            for (Chapter c : b.getChapter()) 
               for (Actor a : c.getActor()) {
                   if (al.contains(a))
                       System.out.printf("WARNING: Duplicate Actor '%s' in chapter '%s  'book '%s'", a.getName(), c.getTitle(), b.getTitle());
                   else
                       al.add(a);
               }
            return al;
        } else if (this instanceof Chapter) {
            Chapter c = (Chapter) this;
            EList<Actor> al = c.getBook().getActors();
            al.addAll(c.getActor());
            return al;
        } else if (this instanceof Scene) {
            Scene b = (Scene) this;
            EList<Actor> al = b.getChapter().getActors();
            return al;
        }
        // else return an empty list
        return new BasicEList<Actor>();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public EList<Location> getLocations() {
      // TODO: implement this method to return the 'Locations' reference list
      // Ensure that you remove @generated or mark it @generated NOT
      // The list is expected to implement org.eclipse.emf.ecore.util.InternalEList and org.eclipse.emf.ecore.EStructuralFeature.Setting
      // so it's likely that an appropriate subclass of org.eclipse.emf.ecore.util.EcoreEList should be used.
        //throw new UnsupportedOperationException();
        return new UniqueEList<Location>();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public EList<Item> getItems() {
      // TODO: implement this method to return the 'Items' reference list
      // Ensure that you remove @generated or mark it @generated NOT
      // The list is expected to implement org.eclipse.emf.ecore.util.InternalEList and org.eclipse.emf.ecore.EStructuralFeature.Setting
      // so it's likely that an appropriate subclass of org.eclipse.emf.ecore.util.EcoreEList should be used.
        //throw new UnsupportedOperationException();
        return new UniqueEList<Item>();
   }

   /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public World getRoot() {
		World root = basicGetRoot();
		return root != null && root.eIsProxy() ? (World)eResolveProxy((InternalEObject)root) : root;
	}

			/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public World basicGetRoot() {
		// DONE: implement this method to return the 'Root' reference
		// -> do not perform proxy resolution
		// Ensure that you remove @generated or mark it @generated NOT
		EObject eo = this;
		while (eo != null) {
			if (eo instanceof World) {
				return (World) eo;
			}
			eo = eo.eContainer();
		}
		throw new UnsupportedOperationException();
	}

			/**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorldPackage.IBASE__TIMELINE:
				if (timeline != null)
					msgs = ((InternalEObject)timeline).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - WorldPackage.IBASE__TIMELINE, null, msgs);
				return basicSetTimeline((Timeline)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorldPackage.IBASE__TIMELINE:
				return basicSetTimeline(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case WorldPackage.IBASE__TITLE:
				return getTitle();
			case WorldPackage.IBASE__UNUSED:
				return isUnused();
			case WorldPackage.IBASE__DESC:
				return getDesc();
			case WorldPackage.IBASE__CONTENT:
				return getContent();
			case WorldPackage.IBASE__TIMELINE:
				return getTimeline();
			case WorldPackage.IBASE__IMAGE:
				return getImage();
			case WorldPackage.IBASE__ACTORS:
				return getActors();
			case WorldPackage.IBASE__LOCATIONS:
				return getLocations();
			case WorldPackage.IBASE__ITEMS:
				return getItems();
			case WorldPackage.IBASE__ROOT:
				if (resolve) return getRoot();
				return basicGetRoot();
		}
		return super.eGet(featureID, resolve, coreType);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case WorldPackage.IBASE__TITLE:
				setTitle((String)newValue);
				return;
			case WorldPackage.IBASE__UNUSED:
				setUnused((Boolean)newValue);
				return;
			case WorldPackage.IBASE__DESC:
				setDesc((String)newValue);
				return;
			case WorldPackage.IBASE__CONTENT:
				setContent((String)newValue);
				return;
			case WorldPackage.IBASE__TIMELINE:
				setTimeline((Timeline)newValue);
				return;
			case WorldPackage.IBASE__IMAGE:
				setImage((Image)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public void eUnset(int featureID) {
		switch (featureID) {
			case WorldPackage.IBASE__TITLE:
				setTitle(TITLE_EDEFAULT);
				return;
			case WorldPackage.IBASE__UNUSED:
				setUnused(UNUSED_EDEFAULT);
				return;
			case WorldPackage.IBASE__DESC:
				unsetDesc();
				return;
			case WorldPackage.IBASE__CONTENT:
				setContent(CONTENT_EDEFAULT);
				return;
			case WorldPackage.IBASE__TIMELINE:
				setTimeline((Timeline)null);
				return;
			case WorldPackage.IBASE__IMAGE:
				unsetImage();
				return;
		}
		super.eUnset(featureID);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public boolean eIsSet(int featureID) {
		switch (featureID) {
			case WorldPackage.IBASE__TITLE:
				return TITLE_EDEFAULT == null ? title != null : !TITLE_EDEFAULT.equals(title);
			case WorldPackage.IBASE__UNUSED:
				return unused != UNUSED_EDEFAULT;
			case WorldPackage.IBASE__DESC:
				return isSetDesc();
			case WorldPackage.IBASE__CONTENT:
				return CONTENT_EDEFAULT == null ? content != null : !CONTENT_EDEFAULT.equals(content);
			case WorldPackage.IBASE__TIMELINE:
				return timeline != null;
			case WorldPackage.IBASE__IMAGE:
				return isSetImage();
			case WorldPackage.IBASE__ACTORS:
				return !getActors().isEmpty();
			case WorldPackage.IBASE__LOCATIONS:
				return !getLocations().isEmpty();
			case WorldPackage.IBASE__ITEMS:
				return !getItems().isEmpty();
			case WorldPackage.IBASE__ROOT:
				return basicGetRoot() != null;
		}
		return super.eIsSet(featureID);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (title: ");
		result.append(title);
		result.append(", unused: ");
		result.append(unused);
		result.append(", desc: ");
		if (descESet) result.append(desc); else result.append("<unset>");
		result.append(", content: ");
		result.append(content);
		result.append(", image: ");
		if (imageESet) result.append(image); else result.append("<unset>");
		result.append(')');
		return result.toString();
	}

} //IBaseImpl
